﻿(define (domain new)
    (:requirements :fluents :equality :typing :durative-actions)

    (:types Item Treatment)

    (:predicates
        (busy)
        (not_busy)
        (treated ?i - Item ?t - Treatment)
        (not_treated ?i - Item ?t - Treatment)
        (started ?i - Item ?t - Treatment)
        (not_started ?i - Item ?t - Treatment)
        (ready ?i - Item ?t - Treatment)
        (consecutive ?t ?next - Treatment)
        (s1 ?i - Item ?t ?next - Treatment)
        (s2 ?i - Item ?t ?next - Treatment)
        (s3 ?i - Item ?t ?next - Treatment)
        (s4 ?i - Item ?t ?next - Treatment)
    )

    (:functions
        (counter ?t - Treatment)
        (item_id ?i - Item)
    )

    (:constants
        last_t - Treatment
    )

    (:durative-action make_treatment1
        :parameters (?i - Item ?t ?next - Treatment)
        :duration (= ?duration 4000)
        :condition 
            (and
                (at start (and
                              (s1 ?i ?t ?next)
                              (= (item_id ?i) (counter ?t))
                              (not_busy)
                              (consecutive ?t ?next)
                              (not_treated ?i ?t)
                              (not_started ?i ?t)
                              (ready ?i ?t)))
            )
        :effect 
            (and
                (at start (and
                              (not (s1 ?i ?t ?next))
                              (increase (counter ?t) 1)
                              (busy)
                              (not (not_busy))
                              (not (not_started ?i ?t))
                              (started ?i ?t)))
                (at end (and
                            (s2 ?i ?t ?next)
                            (treated ?i ?t)
                            (not (not_treated ?i ?t))
                            (not_busy)
                            (not (busy))))
            )
    )

    (:durative-action make_treatment2
        :parameters (?i - Item ?t ?next - Treatment)
        :duration (= ?duration 6000)
        :condition (at start (s2 ?i ?t ?next))
        :effect 
            (and
                (at start (not (s2 ?i ?t ?next)))
                (at end (and
                            (s3 ?i ?t ?next)
                            (ready ?i ?next)))
            )
    )

    (:durative-action make_treatment3
        :parameters (?i - Item ?t ?next - Treatment)
        :duration (= ?duration 5000)
        :condition 
            (and
                (at start (s3 ?i ?t ?next))
                (at end (started ?i ?next))
            )
        :effect 
            (and
                (at start (not (s3 ?i ?t ?next)))
                (at end (s4 ?i ?t ?next))
            )
    )

    (:durative-action make_treatment_container
        :parameters (?i - Item ?t ?next - Treatment)
        :duration (= ?duration 15004)
        :condition (at end (s4 ?i ?t ?next))
        :effect (and
                    (at start (s1 ?i ?t ?next))
                    (at end (not (s4 ?i ?t ?next)))
                 )
    )
    
)


