﻿(define (domain new)

    (:types
        Item - object
        Treatment - object
    )

    (:constants
        last_t - Treatment
    )

    (:predicates
        (busy)
        (treated ?i - Item ?t - Treatment)
        (started ?i - Item ?t - Treatment)
        (ready ?i - Item ?t - Treatment)
        (consecutive ?t ?next - Treatment)
        (s1 ?i - Item ?t ?next - Treatment)
        (s2 ?i - Item ?t ?next - Treatment)
        (s3 ?i - Item ?t ?next - Treatment)
        (s4 ?i - Item ?t ?next - Treatment)
    )

    (:functions
        (counter ?t - Treatment)
        (item_id ?i - Item)
    )

    (:action fix
        :parameters (?i - Item)
        :precondition (not (started ?i last_t))
        :effect (started ?i last_t)
    )

    (:action make_treatment1
        :parameters (?i - Item ?t ?next - Treatment)
        :precondition 
            (and
                (= (item_id ?i) (counter ?t))
                (not (busy))
                (consecutive ?t ?next)
                (not (treated ?i ?t))
                (not (started ?i ?t))
                (ready ?i ?t)
                (not (s1 ?i ?t ?next))
            )
        :effect 
            (and
                (increase (counter ?t) 1)
                (busy)
                (started ?i ?t)
                (s1 ?i ?t ?next)
            )
    )

    (:action make_treatment2
        :parameters (?i - Item ?t ?next - Treatment)
        :precondition 
            (and
                (s1 ?i ?t ?next)
                (not (s2 ?i ?t ?next))
            )
        :effect 
            (and
                (treated ?i ?t)
                (not (busy))
                (s2 ?i ?t ?next)
            )
    )

    (:action make_treatment3
        :parameters (?i - Item ?t ?next - Treatment)
        :precondition 
            (and
                (s2 ?i ?t ?next)
                (not (s3 ?i ?t ?next))
            )
        :effect 
            (and
                (ready ?i ?next)
                (s3 ?i ?t ?next)
            )
    )

    (:action make_treatment4
        :parameters (?i - Item ?t ?next - Treatment)
        :precondition 
            (and
                (s3 ?i ?t ?next)
                (not (s4 ?i ?t ?next))
                (started ?i ?next)
            )
        :effect 
            (and
                (s4 ?i ?t ?next)
            )
    )
    
)


