(define (domain mapanalyzer)
(:requirements :typing :fluents :durative-actions)
  (:types
        car
	junction
	road
	garage - object
	)

  (:predicates
    (connected ?x - junction ?y - junction )
    (at_jun ?c - car ?x - junction)
    (starting ?c - car ?x - garage)
    (arrived ?c - car ?x - junction)
    (road_connect ?r1 - road ?xy - junction ?xy2 - junction)
    (clear ?xy - junction )
    (in_place ?x - road)
    (available ?x - road)
    (at_garage ?g - garage ?xy - junction )

  )
(:functions
	(distance ?initial - junction ?final - junction)
	(build-time)
	(remove-time)
	(speed ?v - car)
	(arrived-time)
	(start-time)
)


(:durative-action move_vehicle_road
  :parameters (?xy_initial - junction ?xy_final - junction ?machine - car ?r1 - road)
  :duration (= ?duration (/ (distance ?xy_initial ?xy_final) (speed ?machine)))
  :condition (and
		(at start (at_jun ?machine ?xy_initial))
		(at start (road_connect ?r1 ?xy_initial ?xy_final))
		(at start (in_place ?r1))
		(at end (clear ?xy_final))
		)
  :effect (and
		(at start (clear ?xy_initial))
		(at end (at_jun ?machine ?xy_final))
		(at start (not (at_jun ?machine ?xy_initial)))
		)
)



(:durative-action vehicle_arrived
  :parameters (?xy_final - junction ?machine - car )
  :duration (= ?duration (arrived-time))
  :condition (and
		(at start (at_jun ?machine ?xy_final))
		)
  :effect (and
		(at end (clear ?xy_final))
		(at end (arrived ?machine ?xy_final))
		(at end (not (at_jun ?machine ?xy_final)))
		)
)


(:durative-action vehicle_start
  :parameters (?xy_final - junction ?machine - car ?g - garage)
  :duration (= ?duration (start-time))
  :condition (and
		(at start (at_garage ?g ?xy_final))
		(at start (starting ?machine ?g))
		(at start (clear ?xy_final))
		)
  :effect (and
		(at end (not (clear ?xy_final)))
		(at end (at_jun ?machine ?xy_final))
		(at start (not (starting ?machine ?g)))
		)
)


(:durative-action build_road
  :parameters (?xy_initial - junction ?xy_final - junction ?r1 - road)
  :duration (= ?duration (* (distance ?xy_initial ?xy_final) (build-time)))
  :condition (and
		(at start (clear ?xy_final))
		(at start (available ?r1))
		(at start (connected ?xy_initial ?xy_final))
		)
  :effect (and
		(at end (road_connect ?r1 ?xy_initial ?xy_final))
		(at end (road_connect ?r1 ?xy_final ?xy_initial))
		(at start (in_place ?r1))
		(at start (not (available ?r1)))
		)
)


(:durative-action remove_road
  :parameters (?xy_initial - junction ?xy_final - junction ?r1 - road)
  :duration (= ?duration (* (distance ?xy_initial ?xy_final) (remove-time)))
  :condition (and
		(at start (road_connect ?r1 ?xy_initial ?xy_final))
		(at start (road_connect ?r1 ?xy_final ?xy_initial))
		(at start (in_place ?r1))
		)
  :effect (and
		(at end (not (in_place ?r1)))
		(at end (available ?r1))
		(at start (not (road_connect ?r1 ?xy_initial ?xy_final)))
		(at start (not (road_connect ?r1 ?xy_final ?xy_initial)))
		)
)




)
