(define (domain driverlog)
(:requirements :strips :typing :durative-actions)
(:types
   location - object
   locatable - object
   driver - locatable
   truck - locatable
   obj - locatable)
(:predicates
   (loc ?obj - locatable ?loc - location)
   (in ?obj1 - obj ?obj - truck)
   (driving ?d - driver ?v - truck)
   (link ?x - location ?y - location)
   (path ?x - location ?y - location)
   (empty ?v - truck)
   (compiled_drive-truck_started)
   (compiled_drive-truck_finished)
   (compiled_drive-truck_stage1_enabled)
   (compiled_drive-truck_stage2_enabled)
   (compiled_shadow_loc ?obj - locatable ?loc - location)
   (compiled_drive-truck_param_0 ?truck - truck)
   (compiled_drive-truck_param_1 ?loc-from - location)
   (compiled_drive-truck_param_2 ?loc-to - location)
   (compiled_drive-truck_param_3 ?driver - driver)
   (compiled_walk_started)
   (compiled_walk_finished)
   (compiled_walk_stage1_enabled)
   (compiled_walk_stage2_enabled)
   (compiled_walk_param_0 ?driver - driver)
   (compiled_walk_param_1 ?loc-from - location)
   (compiled_walk_param_2 ?loc-to - location))
(:durative-action load-truck
:parameters (?obj - obj ?truck - truck ?loc - location)
:duration (= ?duration 2.0)
:condition (and (over all (loc ?truck ?loc)) (at start (loc ?obj ?loc)))
:effect (and (at start (not (loc ?obj ?loc))) (at end (in ?obj ?truck))))
(:durative-action unload-truck
:parameters (?obj - obj ?truck - truck ?loc - location)
:duration (= ?duration 2.0)
:condition (and (over all (loc ?truck ?loc)) (at start (in ?obj ?truck)))
:effect (and (at start (not (in ?obj ?truck))) (at end (loc ?obj ?loc))))
(:durative-action board-truck
:parameters (?driver - driver ?truck - truck ?loc - location)
:duration (= ?duration 1.0)
:condition (and (over all (loc ?truck ?loc)) (at start (loc ?driver ?loc)) (at start (empty ?truck)))
:effect (and (at start (not (loc ?driver ?loc))) (at end (driving ?driver ?truck)) (at start (not (empty ?truck)))))
(:durative-action disembark-truck
:parameters (?driver - driver ?truck - truck ?loc - location)
:duration (= ?duration 1.0)
:condition (and (over all (loc ?truck ?loc)) (at start (driving ?driver ?truck)))
:effect (and (at start (not (driving ?driver ?truck))) (at end (loc ?driver ?loc)) (at end (empty ?truck))))
(:durative-action drive-truck
:parameters (?truck - truck ?loc-from - location ?loc-to - location ?driver - driver)
:duration (= ?duration 10.0)
:condition (and (at start (loc ?truck ?loc-from)) (at start (link ?loc-from ?loc-to)) (at end (compiled_drive-truck_finished)) (over all (driving ?driver ?truck)))
:effect (and (at start (compiled_drive-truck_param_0 ?truck)) (at end (not (compiled_drive-truck_param_0 ?truck))) (at start (compiled_drive-truck_param_1 ?loc-from)) (at end (not (compiled_drive-truck_param_1 ?loc-from))) (at start (compiled_drive-truck_param_2 ?loc-to)) (at end (not (compiled_drive-truck_param_2 ?loc-to))) (at start (compiled_drive-truck_param_3 ?driver)) (at end (not (compiled_drive-truck_param_3 ?driver))) (at start (not (loc ?truck ?loc-from))) (at start (compiled_drive-truck_started)) (at start (compiled_drive-truck_stage1_enabled)) (at end (loc ?truck ?loc-to)) (at end (not (compiled_drive-truck_finished))) (at end (not (compiled_drive-truck_started)))))
(:durative-action compiled_drive-truck_stage1
:parameters (?truck - truck ?loc-from - location ?loc-to - location ?driver - driver)
:duration (= ?duration 7.998)
:condition (and (over all (compiled_drive-truck_param_0 ?truck)) (at start (compiled_drive-truck_param_0 ?truck)) (at end (compiled_drive-truck_param_0 ?truck)) (over all (compiled_drive-truck_param_1 ?loc-from)) (at start (compiled_drive-truck_param_1 ?loc-from)) (at end (compiled_drive-truck_param_1 ?loc-from)) (over all (compiled_drive-truck_param_2 ?loc-to)) (at start (compiled_drive-truck_param_2 ?loc-to)) (at end (compiled_drive-truck_param_2 ?loc-to)) (over all (compiled_drive-truck_param_3 ?driver)) (at start (compiled_drive-truck_param_3 ?driver)) (at end (compiled_drive-truck_param_3 ?driver)) (at start (compiled_drive-truck_started)) (over all (compiled_drive-truck_started)) (at end (compiled_drive-truck_started)) (at start (compiled_drive-truck_stage1_enabled)) (over all (compiled_drive-truck_stage1_enabled)))
:effect (and (at end (not (compiled_drive-truck_stage1_enabled))) (at end (compiled_drive-truck_stage2_enabled))))
(:durative-action compiled_drive-truck_stage2
:parameters (?truck - truck ?loc-from - location ?loc-to - location ?driver - driver)
:duration (= ?duration 1.999)
:condition (and (over all (compiled_drive-truck_param_0 ?truck)) (at start (compiled_drive-truck_param_0 ?truck)) (at end (compiled_drive-truck_param_0 ?truck)) (over all (compiled_drive-truck_param_1 ?loc-from)) (at start (compiled_drive-truck_param_1 ?loc-from)) (at end (compiled_drive-truck_param_1 ?loc-from)) (over all (compiled_drive-truck_param_2 ?loc-to)) (at start (compiled_drive-truck_param_2 ?loc-to)) (at end (compiled_drive-truck_param_2 ?loc-to)) (over all (compiled_drive-truck_param_3 ?driver)) (at start (compiled_drive-truck_param_3 ?driver)) (at end (compiled_drive-truck_param_3 ?driver)) (at start (compiled_drive-truck_started)) (over all (compiled_drive-truck_started)) (at end (compiled_drive-truck_started)) (at start (compiled_drive-truck_stage2_enabled)) (over all (compiled_drive-truck_stage2_enabled)) (over all (compiled_shadow_loc ?truck ?loc-to)))
:effect (and (at end (not (compiled_drive-truck_stage2_enabled))) (at end (compiled_drive-truck_finished)) (at start (compiled_shadow_loc ?truck ?loc-to))))
(:durative-action walk
:parameters (?driver - driver ?loc-from - location ?loc-to - location)
:duration (= ?duration 20.0)
:condition (and (at start (loc ?driver ?loc-from)) (at start (path ?loc-from ?loc-to)) (at end (compiled_walk_finished)))
:effect (and (at start (compiled_walk_param_0 ?driver)) (at end (not (compiled_walk_param_0 ?driver))) (at start (compiled_walk_param_1 ?loc-from)) (at end (not (compiled_walk_param_1 ?loc-from))) (at start (compiled_walk_param_2 ?loc-to)) (at end (not (compiled_walk_param_2 ?loc-to))) (at start (not (loc ?driver ?loc-from))) (at start (compiled_walk_started)) (at start (compiled_walk_stage1_enabled)) (at end (loc ?driver ?loc-to)) (at end (not (compiled_walk_finished))) (at end (not (compiled_walk_started)))))
(:durative-action compiled_walk_stage1
:parameters (?driver - driver ?loc-from - location ?loc-to - location)
:duration (= ?duration 14.998)
:condition (and (over all (compiled_walk_param_0 ?driver)) (at start (compiled_walk_param_0 ?driver)) (at end (compiled_walk_param_0 ?driver)) (over all (compiled_walk_param_1 ?loc-from)) (at start (compiled_walk_param_1 ?loc-from)) (at end (compiled_walk_param_1 ?loc-from)) (over all (compiled_walk_param_2 ?loc-to)) (at start (compiled_walk_param_2 ?loc-to)) (at end (compiled_walk_param_2 ?loc-to)) (at start (compiled_walk_started)) (over all (compiled_walk_started)) (at end (compiled_walk_started)) (at start (compiled_walk_stage1_enabled)) (over all (compiled_walk_stage1_enabled)))
:effect (and (at end (not (compiled_walk_stage1_enabled))) (at end (compiled_walk_stage2_enabled))))
(:durative-action compiled_walk_stage2
:parameters (?driver - driver ?loc-from - location ?loc-to - location)
:duration (= ?duration 4.999)
:condition (and (over all (compiled_walk_param_0 ?driver)) (at start (compiled_walk_param_0 ?driver)) (at end (compiled_walk_param_0 ?driver)) (over all (compiled_walk_param_1 ?loc-from)) (at start (compiled_walk_param_1 ?loc-from)) (at end (compiled_walk_param_1 ?loc-from)) (over all (compiled_walk_param_2 ?loc-to)) (at start (compiled_walk_param_2 ?loc-to)) (at end (compiled_walk_param_2 ?loc-to)) (at start (compiled_walk_started)) (over all (compiled_walk_started)) (at end (compiled_walk_started)) (at start (compiled_walk_stage2_enabled)) (over all (compiled_walk_stage2_enabled)) (over all (compiled_shadow_loc ?driver ?loc-to)))
:effect (and (at end (not (compiled_walk_stage2_enabled))) (at end (compiled_walk_finished)) (at start (compiled_shadow_loc ?driver ?loc-to))))
)
