(define (domain floor-tile)
(:requirements :strips :typing :durative-actions)
(:types
   robot - object
   tile - object
   color - object)
(:predicates
   (robot-at ?r - robot ?x - tile)
   (up ?x - tile ?y - tile)
   (down ?x - tile ?y - tile)
   (right ?x - tile ?y - tile)
   (left ?x - tile ?y - tile)
   (clear ?x - tile)
   (painted ?x - tile ?c - color)
   (robot-has ?r - robot ?c - color)
   (available-color ?c - color)
   (free-color ?r - robot)
   (compiled_shadow_robot-has ?r - robot ?c - color)
   (compiled_change-color_param_0 ?r - robot)
   (compiled_change-color_param_1 ?c - color)
   (compiled_change-color_param_2 ?c2 - color)
   (compiled_change-color_x)
   (compiled_change-color_y)
   (compiled_shadow_painted ?x - tile ?c - color)
   (compiled_paint-up_param_0 ?r - robot)
   (compiled_paint-up_param_1 ?y - tile)
   (compiled_paint-up_param_2 ?x - tile)
   (compiled_paint-up_param_3 ?c - color)
   (compiled_paint-up_x)
   (compiled_paint-up_y)
   (compiled_paint-down_param_0 ?r - robot)
   (compiled_paint-down_param_1 ?y - tile)
   (compiled_paint-down_param_2 ?x - tile)
   (compiled_paint-down_param_3 ?c - color)
   (compiled_paint-down_x)
   (compiled_paint-down_y))
(:durative-action go-up
:parameters (?r - robot ?x - tile ?y - tile)
:duration (= ?duration 3.0)
:condition (and (at start (robot-at ?r ?x)) (over all (up ?y ?x)) (at start (clear ?y)))
:effect (and (at start (not (robot-at ?r ?x))) (at end (robot-at ?r ?y)) (at start (not (clear ?y))) (at end (clear ?x))))
(:durative-action go-down
:parameters (?r - robot ?x - tile ?y - tile)
:duration (= ?duration 1.0)
:condition (and (at start (robot-at ?r ?x)) (over all (down ?y ?x)) (at start (clear ?y)))
:effect (and (at start (not (robot-at ?r ?x))) (at end (robot-at ?r ?y)) (at start (not (clear ?y))) (at end (clear ?x))))
(:durative-action go-right
:parameters (?r - robot ?x - tile ?y - tile)
:duration (= ?duration 1.0)
:condition (and (at start (robot-at ?r ?x)) (over all (right ?y ?x)) (at start (clear ?y)))
:effect (and (at start (not (robot-at ?r ?x))) (at end (robot-at ?r ?y)) (at start (not (clear ?y))) (at end (clear ?x))))
(:durative-action go-left
:parameters (?r - robot ?x - tile ?y - tile)
:duration (= ?duration 1.0)
:condition (and (at start (robot-at ?r ?x)) (over all (left ?y ?x)) (at start (clear ?y)))
:effect (and (at start (not (robot-at ?r ?x))) (at end (robot-at ?r ?y)) (at start (not (clear ?y))) (at end (clear ?x))))
(:durative-action compiled_change-color_clip
:parameters ()
:duration (= ?duration 0.002)
:condition (and (at start (compiled_change-color_y)))
:effect (and (at start (compiled_change-color_x)) (at end (not (compiled_change-color_x)))))
(:durative-action change-color
:parameters (?r - robot ?c - color ?c2 - color)
:duration (= ?duration 3.999)
:condition (and (at end (compiled_change-color_x)) (at start (robot-has ?r ?c)) (over all (available-color ?c2)) (over all (compiled_change-color_param_0 ?r)) (at end (compiled_change-color_param_0 ?r)) (over all (compiled_change-color_param_1 ?c)) (at end (compiled_change-color_param_1 ?c)) (over all (compiled_change-color_param_2 ?c2)) (at end (compiled_change-color_param_2 ?c2)))
:effect (and (at start (compiled_change-color_y)) (at end (not (compiled_change-color_y))) (at start (compiled_change-color_param_0 ?r)) (at start (compiled_change-color_param_1 ?c)) (at start (compiled_change-color_param_2 ?c2)) (at start (not (robot-has ?r ?c)))))
(:durative-action compiled_change-color_stage2
:parameters (?r - robot ?c - color ?c2 - color)
:duration (= ?duration 1.0)
:condition (and (at start (compiled_change-color_x)) (over all (compiled_change-color_param_0 ?r)) (at start (compiled_change-color_param_0 ?r)) (at end (compiled_change-color_param_0 ?r)) (over all (compiled_change-color_param_1 ?c)) (at start (compiled_change-color_param_1 ?c)) (at end (compiled_change-color_param_1 ?c)) (over all (compiled_change-color_param_2 ?c2)) (at start (compiled_change-color_param_2 ?c2)) (at end (compiled_change-color_param_2 ?c2)) (over all (available-color ?c2)) (over all (compiled_shadow_robot-has ?r ?c2)))
:effect (and (at end (not (compiled_change-color_param_0 ?r))) (at end (not (compiled_change-color_param_1 ?c))) (at end (not (compiled_change-color_param_2 ?c2))) (at end (robot-has ?r ?c2)) (at start (compiled_shadow_robot-has ?r ?c2))))
(:durative-action compiled_paint-up_clip
:parameters ()
:duration (= ?duration 0.002)
:condition (and (at start (compiled_paint-up_y)))
:effect (and (at start (compiled_paint-up_x)) (at end (not (compiled_paint-up_x)))))
(:durative-action paint-up
:parameters (?r - robot ?y - tile ?x - tile ?c - color)
:duration (= ?duration 0.999)
:condition (and (at end (compiled_paint-up_x)) (at start (robot-at ?r ?x)) (at start (clear ?y)) (over all (robot-has ?r ?c)) (over all (up ?y ?x)) (over all (compiled_paint-up_param_0 ?r)) (at end (compiled_paint-up_param_0 ?r)) (over all (compiled_paint-up_param_1 ?y)) (at end (compiled_paint-up_param_1 ?y)) (over all (compiled_paint-up_param_2 ?x)) (at end (compiled_paint-up_param_2 ?x)) (over all (compiled_paint-up_param_3 ?c)) (at end (compiled_paint-up_param_3 ?c)))
:effect (and (at start (compiled_paint-up_y)) (at end (not (compiled_paint-up_y))) (at start (compiled_paint-up_param_0 ?r)) (at start (compiled_paint-up_param_1 ?y)) (at start (compiled_paint-up_param_2 ?x)) (at start (compiled_paint-up_param_3 ?c)) (at start (not (clear ?y)))))
(:durative-action compiled_paint-up_stage2
:parameters (?r - robot ?y - tile ?x - tile ?c - color)
:duration (= ?duration 1.0)
:condition (and (at start (compiled_paint-up_x)) (over all (compiled_paint-up_param_0 ?r)) (at start (compiled_paint-up_param_0 ?r)) (at end (compiled_paint-up_param_0 ?r)) (over all (compiled_paint-up_param_1 ?y)) (at start (compiled_paint-up_param_1 ?y)) (at end (compiled_paint-up_param_1 ?y)) (over all (compiled_paint-up_param_2 ?x)) (at start (compiled_paint-up_param_2 ?x)) (at end (compiled_paint-up_param_2 ?x)) (over all (compiled_paint-up_param_3 ?c)) (at start (compiled_paint-up_param_3 ?c)) (at end (compiled_paint-up_param_3 ?c)) (over all (robot-has ?r ?c)) (over all (up ?y ?x)) (over all (compiled_shadow_painted ?y ?c)))
:effect (and (at end (not (compiled_paint-up_param_0 ?r))) (at end (not (compiled_paint-up_param_1 ?y))) (at end (not (compiled_paint-up_param_2 ?x))) (at end (not (compiled_paint-up_param_3 ?c))) (at end (painted ?y ?c)) (at start (compiled_shadow_painted ?y ?c))))
(:durative-action compiled_paint-down_clip
:parameters ()
:duration (= ?duration 0.002)
:condition (and (at start (compiled_paint-down_y)))
:effect (and (at start (compiled_paint-down_x)) (at end (not (compiled_paint-down_x)))))
(:durative-action paint-down
:parameters (?r - robot ?y - tile ?x - tile ?c - color)
:duration (= ?duration 0.999)
:condition (and (at end (compiled_paint-down_x)) (at start (robot-at ?r ?x)) (at start (clear ?y)) (over all (robot-has ?r ?c)) (over all (down ?y ?x)) (over all (compiled_paint-down_param_0 ?r)) (at end (compiled_paint-down_param_0 ?r)) (over all (compiled_paint-down_param_1 ?y)) (at end (compiled_paint-down_param_1 ?y)) (over all (compiled_paint-down_param_2 ?x)) (at end (compiled_paint-down_param_2 ?x)) (over all (compiled_paint-down_param_3 ?c)) (at end (compiled_paint-down_param_3 ?c)))
:effect (and (at start (compiled_paint-down_y)) (at end (not (compiled_paint-down_y))) (at start (compiled_paint-down_param_0 ?r)) (at start (compiled_paint-down_param_1 ?y)) (at start (compiled_paint-down_param_2 ?x)) (at start (compiled_paint-down_param_3 ?c)) (at start (not (clear ?y)))))
(:durative-action compiled_paint-down_stage2
:parameters (?r - robot ?y - tile ?x - tile ?c - color)
:duration (= ?duration 1.0)
:condition (and (at start (compiled_paint-down_x)) (over all (compiled_paint-down_param_0 ?r)) (at start (compiled_paint-down_param_0 ?r)) (at end (compiled_paint-down_param_0 ?r)) (over all (compiled_paint-down_param_1 ?y)) (at start (compiled_paint-down_param_1 ?y)) (at end (compiled_paint-down_param_1 ?y)) (over all (compiled_paint-down_param_2 ?x)) (at start (compiled_paint-down_param_2 ?x)) (at end (compiled_paint-down_param_2 ?x)) (over all (compiled_paint-down_param_3 ?c)) (at start (compiled_paint-down_param_3 ?c)) (at end (compiled_paint-down_param_3 ?c)) (over all (robot-has ?r ?c)) (over all (down ?y ?x)) (over all (compiled_shadow_painted ?y ?c)))
:effect (and (at end (not (compiled_paint-down_param_0 ?r))) (at end (not (compiled_paint-down_param_1 ?y))) (at end (not (compiled_paint-down_param_2 ?x))) (at end (not (compiled_paint-down_param_3 ?c))) (at end (painted ?y ?c)) (at start (compiled_shadow_painted ?y ?c))))
)
