(define (domain floor-tile)
(:requirements :strips :typing :durative-actions)
(:types
   robot - object
   tile - object
   color - object)
(:predicates
   (robot-at ?r - robot ?x - tile)
   (up ?x - tile ?y - tile)
   (down ?x - tile ?y - tile)
   (right ?x - tile ?y - tile)
   (left ?x - tile ?y - tile)
   (clear ?x - tile)
   (painted ?x - tile ?c - color)
   (robot-has ?r - robot ?c - color)
   (available-color ?c - color)
   (free-color ?r - robot)
   (compiled_change-color_started)
   (compiled_change-color_finished)
   (compiled_change-color_stage1_enabled)
   (compiled_change-color_stage2_enabled)
   (compiled_shadow_robot-has ?r - robot ?c - color)
   (compiled_change-color_param_0 ?r - robot)
   (compiled_change-color_param_1 ?c - color)
   (compiled_change-color_param_2 ?c2 - color)
   (compiled_paint-up_started)
   (compiled_paint-up_finished)
   (compiled_paint-up_stage1_enabled)
   (compiled_paint-up_stage2_enabled)
   (compiled_shadow_painted ?x - tile ?c - color)
   (compiled_paint-up_param_0 ?r - robot)
   (compiled_paint-up_param_1 ?y - tile)
   (compiled_paint-up_param_2 ?x - tile)
   (compiled_paint-up_param_3 ?c - color)
   (compiled_paint-down_started)
   (compiled_paint-down_finished)
   (compiled_paint-down_stage1_enabled)
   (compiled_paint-down_stage2_enabled)
   (compiled_paint-down_param_0 ?r - robot)
   (compiled_paint-down_param_1 ?y - tile)
   (compiled_paint-down_param_2 ?x - tile)
   (compiled_paint-down_param_3 ?c - color))
(:durative-action go-up
:parameters (?r - robot ?x - tile ?y - tile)
:duration (= ?duration 3.0)
:condition (and (at start (robot-at ?r ?x)) (over all (up ?y ?x)) (at start (clear ?y)))
:effect (and (at start (not (robot-at ?r ?x))) (at end (robot-at ?r ?y)) (at start (not (clear ?y))) (at end (clear ?x))))
(:durative-action go-down
:parameters (?r - robot ?x - tile ?y - tile)
:duration (= ?duration 1.0)
:condition (and (at start (robot-at ?r ?x)) (over all (down ?y ?x)) (at start (clear ?y)))
:effect (and (at start (not (robot-at ?r ?x))) (at end (robot-at ?r ?y)) (at start (not (clear ?y))) (at end (clear ?x))))
(:durative-action go-right
:parameters (?r - robot ?x - tile ?y - tile)
:duration (= ?duration 1.0)
:condition (and (at start (robot-at ?r ?x)) (over all (right ?y ?x)) (at start (clear ?y)))
:effect (and (at start (not (robot-at ?r ?x))) (at end (robot-at ?r ?y)) (at start (not (clear ?y))) (at end (clear ?x))))
(:durative-action go-left
:parameters (?r - robot ?x - tile ?y - tile)
:duration (= ?duration 1.0)
:condition (and (at start (robot-at ?r ?x)) (over all (left ?y ?x)) (at start (clear ?y)))
:effect (and (at start (not (robot-at ?r ?x))) (at end (robot-at ?r ?y)) (at start (not (clear ?y))) (at end (clear ?x))))
(:durative-action change-color
:parameters (?r - robot ?c - color ?c2 - color)
:duration (= ?duration 5.0)
:condition (and (at start (robot-has ?r ?c)) (at end (compiled_change-color_finished)) (over all (available-color ?c2)))
:effect (and (at start (compiled_change-color_param_0 ?r)) (at end (not (compiled_change-color_param_0 ?r))) (at start (compiled_change-color_param_1 ?c)) (at end (not (compiled_change-color_param_1 ?c))) (at start (compiled_change-color_param_2 ?c2)) (at end (not (compiled_change-color_param_2 ?c2))) (at start (not (robot-has ?r ?c))) (at start (compiled_change-color_started)) (at start (compiled_change-color_stage1_enabled)) (at end (robot-has ?r ?c2)) (at end (not (compiled_change-color_finished))) (at end (not (compiled_change-color_started)))))
(:durative-action compiled_change-color_stage1
:parameters (?r - robot ?c - color ?c2 - color)
:duration (= ?duration 3.998)
:condition (and (over all (compiled_change-color_param_0 ?r)) (at start (compiled_change-color_param_0 ?r)) (at end (compiled_change-color_param_0 ?r)) (over all (compiled_change-color_param_1 ?c)) (at start (compiled_change-color_param_1 ?c)) (at end (compiled_change-color_param_1 ?c)) (over all (compiled_change-color_param_2 ?c2)) (at start (compiled_change-color_param_2 ?c2)) (at end (compiled_change-color_param_2 ?c2)) (at start (compiled_change-color_started)) (over all (compiled_change-color_started)) (at end (compiled_change-color_started)) (at start (compiled_change-color_stage1_enabled)) (over all (compiled_change-color_stage1_enabled)))
:effect (and (at end (not (compiled_change-color_stage1_enabled))) (at end (compiled_change-color_stage2_enabled))))
(:durative-action compiled_change-color_stage2
:parameters (?r - robot ?c - color ?c2 - color)
:duration (= ?duration 0.999)
:condition (and (over all (compiled_change-color_param_0 ?r)) (at start (compiled_change-color_param_0 ?r)) (at end (compiled_change-color_param_0 ?r)) (over all (compiled_change-color_param_1 ?c)) (at start (compiled_change-color_param_1 ?c)) (at end (compiled_change-color_param_1 ?c)) (over all (compiled_change-color_param_2 ?c2)) (at start (compiled_change-color_param_2 ?c2)) (at end (compiled_change-color_param_2 ?c2)) (at start (compiled_change-color_started)) (over all (compiled_change-color_started)) (at end (compiled_change-color_started)) (at start (compiled_change-color_stage2_enabled)) (over all (compiled_change-color_stage2_enabled)) (over all (compiled_shadow_robot-has ?r ?c2)))
:effect (and (at end (not (compiled_change-color_stage2_enabled))) (at end (compiled_change-color_finished)) (at start (compiled_shadow_robot-has ?r ?c2))))
(:durative-action paint-up
:parameters (?r - robot ?y - tile ?x - tile ?c - color)
:duration (= ?duration 2.0)
:condition (and (at start (robot-at ?r ?x)) (at start (clear ?y)) (at end (compiled_paint-up_finished)) (over all (robot-has ?r ?c)) (over all (up ?y ?x)))
:effect (and (at start (compiled_paint-up_param_0 ?r)) (at end (not (compiled_paint-up_param_0 ?r))) (at start (compiled_paint-up_param_1 ?y)) (at end (not (compiled_paint-up_param_1 ?y))) (at start (compiled_paint-up_param_2 ?x)) (at end (not (compiled_paint-up_param_2 ?x))) (at start (compiled_paint-up_param_3 ?c)) (at end (not (compiled_paint-up_param_3 ?c))) (at start (not (clear ?y))) (at start (compiled_paint-up_started)) (at start (compiled_paint-up_stage1_enabled)) (at end (painted ?y ?c)) (at end (not (compiled_paint-up_finished))) (at end (not (compiled_paint-up_started)))))
(:durative-action compiled_paint-up_stage1
:parameters (?r - robot ?y - tile ?x - tile ?c - color)
:duration (= ?duration 0.998)
:condition (and (over all (compiled_paint-up_param_0 ?r)) (at start (compiled_paint-up_param_0 ?r)) (at end (compiled_paint-up_param_0 ?r)) (over all (compiled_paint-up_param_1 ?y)) (at start (compiled_paint-up_param_1 ?y)) (at end (compiled_paint-up_param_1 ?y)) (over all (compiled_paint-up_param_2 ?x)) (at start (compiled_paint-up_param_2 ?x)) (at end (compiled_paint-up_param_2 ?x)) (over all (compiled_paint-up_param_3 ?c)) (at start (compiled_paint-up_param_3 ?c)) (at end (compiled_paint-up_param_3 ?c)) (at start (compiled_paint-up_started)) (over all (compiled_paint-up_started)) (at end (compiled_paint-up_started)) (at start (compiled_paint-up_stage1_enabled)) (over all (compiled_paint-up_stage1_enabled)))
:effect (and (at end (not (compiled_paint-up_stage1_enabled))) (at end (compiled_paint-up_stage2_enabled))))
(:durative-action compiled_paint-up_stage2
:parameters (?r - robot ?y - tile ?x - tile ?c - color)
:duration (= ?duration 0.999)
:condition (and (over all (compiled_paint-up_param_0 ?r)) (at start (compiled_paint-up_param_0 ?r)) (at end (compiled_paint-up_param_0 ?r)) (over all (compiled_paint-up_param_1 ?y)) (at start (compiled_paint-up_param_1 ?y)) (at end (compiled_paint-up_param_1 ?y)) (over all (compiled_paint-up_param_2 ?x)) (at start (compiled_paint-up_param_2 ?x)) (at end (compiled_paint-up_param_2 ?x)) (over all (compiled_paint-up_param_3 ?c)) (at start (compiled_paint-up_param_3 ?c)) (at end (compiled_paint-up_param_3 ?c)) (at start (compiled_paint-up_started)) (over all (compiled_paint-up_started)) (at end (compiled_paint-up_started)) (at start (compiled_paint-up_stage2_enabled)) (over all (compiled_paint-up_stage2_enabled)) (over all (compiled_shadow_painted ?y ?c)))
:effect (and (at end (not (compiled_paint-up_stage2_enabled))) (at end (compiled_paint-up_finished)) (at start (compiled_shadow_painted ?y ?c))))
(:durative-action paint-down
:parameters (?r - robot ?y - tile ?x - tile ?c - color)
:duration (= ?duration 2.0)
:condition (and (at start (robot-at ?r ?x)) (at start (clear ?y)) (at end (compiled_paint-down_finished)) (over all (robot-has ?r ?c)) (over all (down ?y ?x)))
:effect (and (at start (compiled_paint-down_param_0 ?r)) (at end (not (compiled_paint-down_param_0 ?r))) (at start (compiled_paint-down_param_1 ?y)) (at end (not (compiled_paint-down_param_1 ?y))) (at start (compiled_paint-down_param_2 ?x)) (at end (not (compiled_paint-down_param_2 ?x))) (at start (compiled_paint-down_param_3 ?c)) (at end (not (compiled_paint-down_param_3 ?c))) (at start (not (clear ?y))) (at start (compiled_paint-down_started)) (at start (compiled_paint-down_stage1_enabled)) (at end (painted ?y ?c)) (at end (not (compiled_paint-down_finished))) (at end (not (compiled_paint-down_started)))))
(:durative-action compiled_paint-down_stage1
:parameters (?r - robot ?y - tile ?x - tile ?c - color)
:duration (= ?duration 0.998)
:condition (and (over all (compiled_paint-down_param_0 ?r)) (at start (compiled_paint-down_param_0 ?r)) (at end (compiled_paint-down_param_0 ?r)) (over all (compiled_paint-down_param_1 ?y)) (at start (compiled_paint-down_param_1 ?y)) (at end (compiled_paint-down_param_1 ?y)) (over all (compiled_paint-down_param_2 ?x)) (at start (compiled_paint-down_param_2 ?x)) (at end (compiled_paint-down_param_2 ?x)) (over all (compiled_paint-down_param_3 ?c)) (at start (compiled_paint-down_param_3 ?c)) (at end (compiled_paint-down_param_3 ?c)) (at start (compiled_paint-down_started)) (over all (compiled_paint-down_started)) (at end (compiled_paint-down_started)) (at start (compiled_paint-down_stage1_enabled)) (over all (compiled_paint-down_stage1_enabled)))
:effect (and (at end (not (compiled_paint-down_stage1_enabled))) (at end (compiled_paint-down_stage2_enabled))))
(:durative-action compiled_paint-down_stage2
:parameters (?r - robot ?y - tile ?x - tile ?c - color)
:duration (= ?duration 0.999)
:condition (and (over all (compiled_paint-down_param_0 ?r)) (at start (compiled_paint-down_param_0 ?r)) (at end (compiled_paint-down_param_0 ?r)) (over all (compiled_paint-down_param_1 ?y)) (at start (compiled_paint-down_param_1 ?y)) (at end (compiled_paint-down_param_1 ?y)) (over all (compiled_paint-down_param_2 ?x)) (at start (compiled_paint-down_param_2 ?x)) (at end (compiled_paint-down_param_2 ?x)) (over all (compiled_paint-down_param_3 ?c)) (at start (compiled_paint-down_param_3 ?c)) (at end (compiled_paint-down_param_3 ?c)) (at start (compiled_paint-down_started)) (over all (compiled_paint-down_started)) (at end (compiled_paint-down_started)) (at start (compiled_paint-down_stage2_enabled)) (over all (compiled_paint-down_stage2_enabled)) (over all (compiled_shadow_painted ?y ?c)))
:effect (and (at end (not (compiled_paint-down_stage2_enabled))) (at end (compiled_paint-down_finished)) (at start (compiled_shadow_painted ?y ?c))))
)
