(define (domain mapanalyzer)
(:requirements :strips :typing :durative-actions :fluents)
(:types
   vehicle - object
   junction - object
   road - object
   garage - object
   car - vehicle)
(:predicates
   (connected ?x - junction ?y - junction)
   (at_jun ?c - vehicle ?x - junction)
   (starting ?c - vehicle ?x - garage)
   (arrived ?c - vehicle ?x - junction)
   (road_connect ?r1 - road ?xy - junction ?xy2 - junction)
   (clear ?xy - junction)
   (in_place ?x - road)
   (available ?x - road)
   (at_garage ?g - garage ?xy - junction)
   (compiled_move_vehicle_road_started)
   (compiled_move_vehicle_road_finished)
   (compiled_move_vehicle_road_stage1_enabled)
   (compiled_move_vehicle_road_stage2_enabled)
   (compiled_shadow_at_jun ?c - vehicle ?x - junction)
   (compiled_move_vehicle_road_param_0 ?xy_initial - junction)
   (compiled_move_vehicle_road_param_1 ?xy_final - junction)
   (compiled_move_vehicle_road_param_2 ?machine - vehicle)
   (compiled_move_vehicle_road_param_3 ?r1 - road)
   (compiled_build_road_started)
   (compiled_build_road_finished)
   (compiled_build_road_stage1_enabled)
   (compiled_build_road_stage2_enabled)
   (compiled_shadow_road_connect ?r1 - road ?xy - junction ?xy2 - junction)
   (compiled_build_road_param_0 ?xy_initial - junction)
   (compiled_build_road_param_1 ?xy_final - junction)
   (compiled_build_road_param_2 ?r1 - road))
(:functions
   (distance ?initial - junction ?final - junction) - number
   (build-time) - number
   (remove-time) - number
   (speed ?v - vehicle) - number
   (arrived-time) - number
   (start-time) - number)
(:durative-action vehicle_arrived
:parameters (?xy_final - junction ?machine - vehicle)
:duration (= ?duration (* 1000 (arrived-time)))
:condition (and (at start (at_jun ?machine ?xy_final)) (at start (compiled_shadow_at_jun ?machine ?xy_final)))
:effect (and (at end (not (compiled_shadow_at_jun ?machine ?xy_final))) (at end (clear ?xy_final)) (at end (arrived ?machine ?xy_final)) (at end (not (at_jun ?machine ?xy_final)))))
(:durative-action vehicle_start
:parameters (?xy_final - junction ?machine - vehicle ?g - garage)
:duration (= ?duration (* 1000 (start-time)))
:condition (and (at start (at_garage ?g ?xy_final)) (at start (starting ?machine ?g)) (at start (clear ?xy_final)))
:effect (and (at end (compiled_shadow_at_jun ?machine ?xy_final)) (at end (not (clear ?xy_final))) (at end (at_jun ?machine ?xy_final)) (at start (not (starting ?machine ?g)))))
(:durative-action remove_road
:parameters (?xy_initial - junction ?xy_final - junction ?r1 - road)
:duration (= ?duration (* 1000 (* (distance ?xy_initial ?xy_final) (remove-time))))
:condition (and (at start (road_connect ?r1 ?xy_initial ?xy_final)) (at start (road_connect ?r1 ?xy_final ?xy_initial)) (at start (in_place ?r1)) (at start (compiled_shadow_road_connect ?r1 ?xy_final ?xy_initial)) (at start (compiled_shadow_road_connect ?r1 ?xy_initial ?xy_final)))
:effect (and (at start (not (compiled_shadow_road_connect ?r1 ?xy_initial ?xy_final))) (at start (not (compiled_shadow_road_connect ?r1 ?xy_final ?xy_initial))) (at end (not (in_place ?r1))) (at end (available ?r1)) (at start (not (road_connect ?r1 ?xy_initial ?xy_final))) (at start (not (road_connect ?r1 ?xy_final ?xy_initial)))))
(:durative-action move_vehicle_road
:parameters (?xy_initial - junction ?xy_final - junction ?machine - vehicle ?r1 - road)
:duration (= ?duration (* 1000 (/ (distance ?xy_initial ?xy_final) (speed ?machine))))
:condition (and (at start (at_jun ?machine ?xy_initial)) (at start (road_connect ?r1 ?xy_initial ?xy_final)) (at start (in_place ?r1)) (at end (compiled_move_vehicle_road_finished)) (at start (compiled_shadow_road_connect ?r1 ?xy_initial ?xy_final)))
:effect (and (at start (compiled_move_vehicle_road_param_0 ?xy_initial)) (at end (not (compiled_move_vehicle_road_param_0 ?xy_initial))) (at start (compiled_move_vehicle_road_param_1 ?xy_final)) (at end (not (compiled_move_vehicle_road_param_1 ?xy_final))) (at start (compiled_move_vehicle_road_param_2 ?machine)) (at end (not (compiled_move_vehicle_road_param_2 ?machine))) (at start (compiled_move_vehicle_road_param_3 ?r1)) (at end (not (compiled_move_vehicle_road_param_3 ?r1))) (at start (clear ?xy_initial)) (at start (not (at_jun ?machine ?xy_initial))) (at start (compiled_move_vehicle_road_started)) (at start (compiled_move_vehicle_road_stage1_enabled)) (at end (at_jun ?machine ?xy_final)) (at end (not (compiled_move_vehicle_road_finished))) (at end (not (compiled_move_vehicle_road_started)))))
(:durative-action compiled_move_vehicle_road_stage1
:parameters (?xy_initial - junction ?xy_final - junction ?machine - vehicle ?r1 - road)
:duration (= ?duration (* 1000 (- (- (/ (distance ?xy_initial ?xy_final) (speed ?machine)) 1.0) 0.002)))
:condition (and (over all (compiled_move_vehicle_road_param_0 ?xy_initial)) (at start (compiled_move_vehicle_road_param_0 ?xy_initial)) (at end (compiled_move_vehicle_road_param_0 ?xy_initial)) (over all (compiled_move_vehicle_road_param_1 ?xy_final)) (at start (compiled_move_vehicle_road_param_1 ?xy_final)) (at end (compiled_move_vehicle_road_param_1 ?xy_final)) (over all (compiled_move_vehicle_road_param_2 ?machine)) (at start (compiled_move_vehicle_road_param_2 ?machine)) (at end (compiled_move_vehicle_road_param_2 ?machine)) (over all (compiled_move_vehicle_road_param_3 ?r1)) (at start (compiled_move_vehicle_road_param_3 ?r1)) (at end (compiled_move_vehicle_road_param_3 ?r1)) (at start (compiled_move_vehicle_road_started)) (over all (compiled_move_vehicle_road_started)) (at end (compiled_move_vehicle_road_started)) (at start (compiled_move_vehicle_road_stage1_enabled)) (over all (compiled_move_vehicle_road_stage1_enabled)))
:effect (and (at end (not (compiled_move_vehicle_road_stage1_enabled))) (at end (compiled_move_vehicle_road_stage2_enabled))))
(:durative-action compiled_move_vehicle_road_stage2
:parameters (?xy_initial - junction ?xy_final - junction ?machine - vehicle ?r1 - road)
:duration (= ?duration (* 1000 (- (- (/ (distance ?xy_initial ?xy_final) (speed ?machine)) (- (/ (distance ?xy_initial ?xy_final) (speed ?machine)) 1.0)) 0.001)))
:condition (and (over all (compiled_move_vehicle_road_param_0 ?xy_initial)) (at start (compiled_move_vehicle_road_param_0 ?xy_initial)) (at end (compiled_move_vehicle_road_param_0 ?xy_initial)) (over all (compiled_move_vehicle_road_param_1 ?xy_final)) (at start (compiled_move_vehicle_road_param_1 ?xy_final)) (at end (compiled_move_vehicle_road_param_1 ?xy_final)) (over all (compiled_move_vehicle_road_param_2 ?machine)) (at start (compiled_move_vehicle_road_param_2 ?machine)) (at end (compiled_move_vehicle_road_param_2 ?machine)) (over all (compiled_move_vehicle_road_param_3 ?r1)) (at start (compiled_move_vehicle_road_param_3 ?r1)) (at end (compiled_move_vehicle_road_param_3 ?r1)) (at start (compiled_move_vehicle_road_started)) (over all (compiled_move_vehicle_road_started)) (at end (compiled_move_vehicle_road_started)) (at start (clear ?xy_final)) (over all (clear ?xy_final)) (at end (clear ?xy_final)) (at start (compiled_move_vehicle_road_stage2_enabled)) (over all (compiled_move_vehicle_road_stage2_enabled)) (over all (compiled_shadow_at_jun ?machine ?xy_final)))
:effect (and (at end (not (compiled_move_vehicle_road_stage2_enabled))) (at end (compiled_move_vehicle_road_finished)) (at start (compiled_shadow_at_jun ?machine ?xy_final))))
(:durative-action build_road
:parameters (?xy_initial - junction ?xy_final - junction ?r1 - road)
:duration (= ?duration (* 1000 (* (distance ?xy_initial ?xy_final) (build-time))))
:condition (and (at start (clear ?xy_final)) (at start (available ?r1)) (at start (connected ?xy_initial ?xy_final)) (at end (compiled_build_road_finished)))
:effect (and (at start (compiled_build_road_param_0 ?xy_initial)) (at end (not (compiled_build_road_param_0 ?xy_initial))) (at start (compiled_build_road_param_1 ?xy_final)) (at end (not (compiled_build_road_param_1 ?xy_final))) (at start (compiled_build_road_param_2 ?r1)) (at end (not (compiled_build_road_param_2 ?r1))) (at start (in_place ?r1)) (at start (not (available ?r1))) (at start (compiled_build_road_started)) (at start (compiled_build_road_stage1_enabled)) (at end (road_connect ?r1 ?xy_initial ?xy_final)) (at end (road_connect ?r1 ?xy_final ?xy_initial)) (at end (not (compiled_build_road_finished))) (at end (not (compiled_build_road_started)))))
(:durative-action compiled_build_road_stage1
:parameters (?xy_initial - junction ?xy_final - junction ?r1 - road)
:duration (= ?duration (* 1000 (- (- (* (distance ?xy_initial ?xy_final) (build-time)) 1.0) 0.002)))
:condition (and (over all (compiled_build_road_param_0 ?xy_initial)) (at start (compiled_build_road_param_0 ?xy_initial)) (at end (compiled_build_road_param_0 ?xy_initial)) (over all (compiled_build_road_param_1 ?xy_final)) (at start (compiled_build_road_param_1 ?xy_final)) (at end (compiled_build_road_param_1 ?xy_final)) (over all (compiled_build_road_param_2 ?r1)) (at start (compiled_build_road_param_2 ?r1)) (at end (compiled_build_road_param_2 ?r1)) (at start (compiled_build_road_started)) (over all (compiled_build_road_started)) (at end (compiled_build_road_started)) (at start (compiled_build_road_stage1_enabled)) (over all (compiled_build_road_stage1_enabled)))
:effect (and (at end (not (compiled_build_road_stage1_enabled))) (at end (compiled_build_road_stage2_enabled))))
(:durative-action compiled_build_road_stage2
:parameters (?xy_initial - junction ?xy_final - junction ?r1 - road)
:duration (= ?duration (* 1000 (- (- (* (distance ?xy_initial ?xy_final) (build-time)) (- (* (distance ?xy_initial ?xy_final) (build-time)) 1.0)) 0.001)))
:condition (and (over all (compiled_build_road_param_0 ?xy_initial)) (at start (compiled_build_road_param_0 ?xy_initial)) (at end (compiled_build_road_param_0 ?xy_initial)) (over all (compiled_build_road_param_1 ?xy_final)) (at start (compiled_build_road_param_1 ?xy_final)) (at end (compiled_build_road_param_1 ?xy_final)) (over all (compiled_build_road_param_2 ?r1)) (at start (compiled_build_road_param_2 ?r1)) (at end (compiled_build_road_param_2 ?r1)) (at start (compiled_build_road_started)) (over all (compiled_build_road_started)) (at end (compiled_build_road_started)) (at start (compiled_build_road_stage2_enabled)) (over all (compiled_build_road_stage2_enabled)) (over all (compiled_shadow_road_connect ?r1 ?xy_initial ?xy_final)) (over all (compiled_shadow_road_connect ?r1 ?xy_final ?xy_initial)))
:effect (and (at end (not (compiled_build_road_stage2_enabled))) (at end (compiled_build_road_finished)) (at start (compiled_shadow_road_connect ?r1 ?xy_initial ?xy_final)) (at start (compiled_shadow_road_connect ?r1 ?xy_final ?xy_initial))))
)
