(define (domain satellite)
(:requirements :strips :equality :typing :durative-actions)
(:types
   satellite - object
   direction - object
   instrument - object
   mode - object)
(:predicates
   (on_board ?i - instrument ?s - satellite)
   (supports ?i - instrument ?m - mode)
   (pointing ?s - satellite ?d - direction)
   (power_avail ?s - satellite)
   (power_on ?i - instrument)
   (calibrated ?i - instrument)
   (have_image ?d - direction ?m - mode)
   (calibration_target ?i - instrument ?d - direction)
   (compiled_shadow_pointing ?s - satellite ?d - direction)
   (compiled_turn_to_param_0 ?s - satellite)
   (compiled_turn_to_param_1 ?d_new - direction)
   (compiled_turn_to_param_2 ?d_prev - direction)
   (compiled_turn_to_x)
   (compiled_turn_to_y)
   (compiled_shadow_power_on ?i - instrument)
   (compiled_switch_on_param_0 ?i - instrument)
   (compiled_switch_on_param_1 ?s - satellite)
   (compiled_switch_on_x)
   (compiled_switch_on_y)
   (compiled_shadow_calibrated ?i - instrument)
   (compiled_calibrate_param_0 ?s - satellite)
   (compiled_calibrate_param_1 ?i - instrument)
   (compiled_calibrate_param_2 ?d - direction)
   (compiled_calibrate_x)
   (compiled_calibrate_y)
   (compiled_shadow_have_image ?d - direction ?m - mode)
   (compiled_take_image_param_0 ?s - satellite)
   (compiled_take_image_param_1 ?d - direction)
   (compiled_take_image_param_2 ?i - instrument)
   (compiled_take_image_param_3 ?m - mode)
   (compiled_take_image_x)
   (compiled_take_image_y))
(:durative-action switch_off
:parameters (?i - instrument ?s - satellite)
:duration (= ?duration 1.0)
:condition (and (over all (on_board ?i ?s)) (at start (power_on ?i)) (at start (compiled_shadow_power_on ?i)))
:effect (and (at start (not (compiled_shadow_power_on ?i))) (at start (not (power_on ?i))) (at end (power_avail ?s))))
(:durative-action compiled_turn_to_clip
:parameters ()
:duration (= ?duration 0.002)
:condition (and (at start (compiled_turn_to_y)))
:effect (and (at start (compiled_turn_to_x)) (at end (not (compiled_turn_to_x)))))
(:durative-action turn_to
:parameters (?s - satellite ?d_new - direction ?d_prev - direction)
:duration (= ?duration 3.999)
:condition (and (at end (compiled_turn_to_x)) (at start (pointing ?s ?d_prev)) (at start (not (= ?d_new ?d_prev))) (over all (compiled_turn_to_param_0 ?s)) (at end (compiled_turn_to_param_0 ?s)) (over all (compiled_turn_to_param_1 ?d_new)) (at end (compiled_turn_to_param_1 ?d_new)) (over all (compiled_turn_to_param_2 ?d_prev)) (at end (compiled_turn_to_param_2 ?d_prev)))
:effect (and (at start (compiled_turn_to_y)) (at end (not (compiled_turn_to_y))) (at start (compiled_turn_to_param_0 ?s)) (at start (compiled_turn_to_param_1 ?d_new)) (at start (compiled_turn_to_param_2 ?d_prev)) (at start (not (pointing ?s ?d_prev)))))
(:durative-action compiled_turn_to_stage2
:parameters (?s - satellite ?d_new - direction ?d_prev - direction)
:duration (= ?duration 1.0)
:condition (and (at start (compiled_turn_to_x)) (over all (compiled_turn_to_param_0 ?s)) (at start (compiled_turn_to_param_0 ?s)) (at end (compiled_turn_to_param_0 ?s)) (over all (compiled_turn_to_param_1 ?d_new)) (at start (compiled_turn_to_param_1 ?d_new)) (at end (compiled_turn_to_param_1 ?d_new)) (over all (compiled_turn_to_param_2 ?d_prev)) (at start (compiled_turn_to_param_2 ?d_prev)) (at end (compiled_turn_to_param_2 ?d_prev)) (over all (compiled_shadow_pointing ?s ?d_new)))
:effect (and (at end (not (compiled_turn_to_param_0 ?s))) (at end (not (compiled_turn_to_param_1 ?d_new))) (at end (not (compiled_turn_to_param_2 ?d_prev))) (at end (pointing ?s ?d_new)) (at start (compiled_shadow_pointing ?s ?d_new))))
(:durative-action compiled_switch_on_clip
:parameters ()
:duration (= ?duration 0.002)
:condition (and (at start (compiled_switch_on_y)))
:effect (and (at start (compiled_switch_on_x)) (at end (not (compiled_switch_on_x)))))
(:durative-action switch_on
:parameters (?i - instrument ?s - satellite)
:duration (= ?duration 0.999)
:condition (and (at end (compiled_switch_on_x)) (at start (power_avail ?s)) (over all (on_board ?i ?s)) (over all (compiled_switch_on_param_0 ?i)) (at end (compiled_switch_on_param_0 ?i)) (over all (compiled_switch_on_param_1 ?s)) (at end (compiled_switch_on_param_1 ?s)))
:effect (and (at start (not (compiled_shadow_calibrated ?i))) (at start (compiled_switch_on_y)) (at end (not (compiled_switch_on_y))) (at start (compiled_switch_on_param_0 ?i)) (at start (compiled_switch_on_param_1 ?s)) (at start (not (calibrated ?i))) (at start (not (power_avail ?s)))))
(:durative-action compiled_switch_on_stage2
:parameters (?i - instrument ?s - satellite)
:duration (= ?duration 1.0)
:condition (and (at start (compiled_switch_on_x)) (over all (compiled_switch_on_param_0 ?i)) (at start (compiled_switch_on_param_0 ?i)) (at end (compiled_switch_on_param_0 ?i)) (over all (compiled_switch_on_param_1 ?s)) (at start (compiled_switch_on_param_1 ?s)) (at end (compiled_switch_on_param_1 ?s)) (over all (on_board ?i ?s)) (over all (compiled_shadow_power_on ?i)))
:effect (and (at end (not (compiled_switch_on_param_0 ?i))) (at end (not (compiled_switch_on_param_1 ?s))) (at end (power_on ?i)) (at start (compiled_shadow_power_on ?i))))
(:durative-action compiled_calibrate_clip
:parameters ()
:duration (= ?duration 0.002)
:condition (and (at start (compiled_calibrate_y)))
:effect (and (at start (compiled_calibrate_x)) (at end (not (compiled_calibrate_x)))))
(:durative-action calibrate
:parameters (?s - satellite ?i - instrument ?d - direction)
:duration (= ?duration 3.999)
:condition (and (at end (compiled_calibrate_x)) (at start (pointing ?s ?d)) (over all (on_board ?i ?s)) (over all (calibration_target ?i ?d)) (over all (power_on ?i)) (over all (compiled_calibrate_param_0 ?s)) (at end (compiled_calibrate_param_0 ?s)) (over all (compiled_calibrate_param_1 ?i)) (at end (compiled_calibrate_param_1 ?i)) (over all (compiled_calibrate_param_2 ?d)) (at end (compiled_calibrate_param_2 ?d)) (over all (compiled_shadow_power_on ?i)))
:effect (and (at start (compiled_calibrate_y)) (at end (not (compiled_calibrate_y))) (at start (compiled_calibrate_param_0 ?s)) (at start (compiled_calibrate_param_1 ?i)) (at start (compiled_calibrate_param_2 ?d))))
(:durative-action compiled_calibrate_stage2
:parameters (?s - satellite ?i - instrument ?d - direction)
:duration (= ?duration 1.0)
:condition (and (at start (compiled_calibrate_x)) (over all (compiled_calibrate_param_0 ?s)) (at start (compiled_calibrate_param_0 ?s)) (at end (compiled_calibrate_param_0 ?s)) (over all (compiled_calibrate_param_1 ?i)) (at start (compiled_calibrate_param_1 ?i)) (at end (compiled_calibrate_param_1 ?i)) (over all (compiled_calibrate_param_2 ?d)) (at start (compiled_calibrate_param_2 ?d)) (at end (compiled_calibrate_param_2 ?d)) (over all (on_board ?i ?s)) (over all (calibration_target ?i ?d)) (over all (power_on ?i)) (at start (power_on ?i)) (at end (power_on ?i)) (over all (compiled_shadow_calibrated ?i)) (over all (compiled_shadow_power_on ?i)) (at start (compiled_shadow_power_on ?i)) (at end (compiled_shadow_power_on ?i)))
:effect (and (at end (not (compiled_calibrate_param_0 ?s))) (at end (not (compiled_calibrate_param_1 ?i))) (at end (not (compiled_calibrate_param_2 ?d))) (at end (calibrated ?i)) (at start (compiled_shadow_calibrated ?i))))
(:durative-action compiled_take_image_clip
:parameters ()
:duration (= ?duration 0.002)
:condition (and (at start (compiled_take_image_y)))
:effect (and (at start (compiled_take_image_x)) (at end (not (compiled_take_image_x)))))
(:durative-action take_image
:parameters (?s - satellite ?d - direction ?i - instrument ?m - mode)
:duration (= ?duration 4.999)
:condition (and (at end (compiled_take_image_x)) (over all (calibrated ?i)) (over all (on_board ?i ?s)) (over all (supports ?i ?m)) (over all (power_on ?i)) (over all (pointing ?s ?d)) (over all (compiled_take_image_param_0 ?s)) (at end (compiled_take_image_param_0 ?s)) (over all (compiled_take_image_param_1 ?d)) (at end (compiled_take_image_param_1 ?d)) (over all (compiled_take_image_param_2 ?i)) (at end (compiled_take_image_param_2 ?i)) (over all (compiled_take_image_param_3 ?m)) (at end (compiled_take_image_param_3 ?m)) (over all (compiled_shadow_power_on ?i)) (over all (compiled_shadow_calibrated ?i)))
:effect (and (at start (compiled_take_image_y)) (at end (not (compiled_take_image_y))) (at start (compiled_take_image_param_0 ?s)) (at start (compiled_take_image_param_1 ?d)) (at start (compiled_take_image_param_2 ?i)) (at start (compiled_take_image_param_3 ?m))))
(:durative-action compiled_take_image_stage2
:parameters (?s - satellite ?d - direction ?i - instrument ?m - mode)
:duration (= ?duration 2.0)
:condition (and (at start (compiled_take_image_x)) (over all (compiled_take_image_param_0 ?s)) (at start (compiled_take_image_param_0 ?s)) (at end (compiled_take_image_param_0 ?s)) (over all (compiled_take_image_param_1 ?d)) (at start (compiled_take_image_param_1 ?d)) (at end (compiled_take_image_param_1 ?d)) (over all (compiled_take_image_param_2 ?i)) (at start (compiled_take_image_param_2 ?i)) (at end (compiled_take_image_param_2 ?i)) (over all (compiled_take_image_param_3 ?m)) (at start (compiled_take_image_param_3 ?m)) (at end (compiled_take_image_param_3 ?m)) (over all (calibrated ?i)) (over all (on_board ?i ?s)) (over all (supports ?i ?m)) (over all (power_on ?i)) (over all (pointing ?s ?d)) (at start (power_on ?i)) (at end (power_on ?i)) (over all (compiled_shadow_have_image ?d ?m)) (over all (compiled_shadow_power_on ?i)) (at start (compiled_shadow_power_on ?i)) (at end (compiled_shadow_power_on ?i)) (over all (compiled_shadow_calibrated ?i)))
:effect (and (at end (not (compiled_take_image_param_0 ?s))) (at end (not (compiled_take_image_param_1 ?d))) (at end (not (compiled_take_image_param_2 ?i))) (at end (not (compiled_take_image_param_3 ?m))) (at end (have_image ?d ?m)) (at start (compiled_shadow_have_image ?d ?m))))
)
