(define (domain satellite)
(:requirements :strips :equality :typing :durative-actions)
(:types
   satellite - object
   direction - object
   instrument - object
   mode - object)
(:predicates
   (on_board ?i - instrument ?s - satellite)
   (supports ?i - instrument ?m - mode)
   (pointing ?s - satellite ?d - direction)
   (power_avail ?s - satellite)
   (power_on ?i - instrument)
   (calibrated ?i - instrument)
   (have_image ?d - direction ?m - mode)
   (calibration_target ?i - instrument ?d - direction)
   (compiled_turn_to_started)
   (compiled_turn_to_finished)
   (compiled_turn_to_stage1_enabled)
   (compiled_turn_to_stage2_enabled)
   (compiled_shadow_pointing ?s - satellite ?d - direction)
   (compiled_turn_to_param_0 ?s - satellite)
   (compiled_turn_to_param_1 ?d_new - direction)
   (compiled_turn_to_param_2 ?d_prev - direction)
   (compiled_switch_on_started)
   (compiled_switch_on_finished)
   (compiled_switch_on_stage1_enabled)
   (compiled_switch_on_stage2_enabled)
   (compiled_shadow_power_on ?i - instrument)
   (compiled_switch_on_param_0 ?i - instrument)
   (compiled_switch_on_param_1 ?s - satellite)
   (compiled_calibrate_started)
   (compiled_calibrate_finished)
   (compiled_calibrate_stage1_enabled)
   (compiled_calibrate_stage2_enabled)
   (compiled_shadow_calibrated ?i - instrument)
   (compiled_calibrate_param_0 ?s - satellite)
   (compiled_calibrate_param_1 ?i - instrument)
   (compiled_calibrate_param_2 ?d - direction)
   (compiled_take_image_started)
   (compiled_take_image_finished)
   (compiled_take_image_stage1_enabled)
   (compiled_take_image_stage2_enabled)
   (compiled_shadow_have_image ?d - direction ?m - mode)
   (compiled_take_image_param_0 ?s - satellite)
   (compiled_take_image_param_1 ?d - direction)
   (compiled_take_image_param_2 ?i - instrument)
   (compiled_take_image_param_3 ?m - mode))
(:durative-action switch_off
:parameters (?i - instrument ?s - satellite)
:duration (= ?duration 1.0)
:condition (and (over all (on_board ?i ?s)) (at start (power_on ?i)) (at start (compiled_shadow_power_on ?i)))
:effect (and (at start (not (compiled_shadow_power_on ?i))) (at start (not (power_on ?i))) (at end (power_avail ?s))))
(:durative-action turn_to
:parameters (?s - satellite ?d_new - direction ?d_prev - direction)
:duration (= ?duration 5.0)
:condition (and (at start (pointing ?s ?d_prev)) (at start (not (= ?d_new ?d_prev))) (at end (compiled_turn_to_finished)))
:effect (and (at start (compiled_turn_to_param_0 ?s)) (at end (not (compiled_turn_to_param_0 ?s))) (at start (compiled_turn_to_param_1 ?d_new)) (at end (not (compiled_turn_to_param_1 ?d_new))) (at start (compiled_turn_to_param_2 ?d_prev)) (at end (not (compiled_turn_to_param_2 ?d_prev))) (at start (not (pointing ?s ?d_prev))) (at start (compiled_turn_to_started)) (at start (compiled_turn_to_stage1_enabled)) (at end (pointing ?s ?d_new)) (at end (not (compiled_turn_to_finished))) (at end (not (compiled_turn_to_started)))))
(:durative-action compiled_turn_to_stage1
:parameters (?s - satellite ?d_new - direction ?d_prev - direction)
:duration (= ?duration 3.998)
:condition (and (over all (compiled_turn_to_param_0 ?s)) (at start (compiled_turn_to_param_0 ?s)) (at end (compiled_turn_to_param_0 ?s)) (over all (compiled_turn_to_param_1 ?d_new)) (at start (compiled_turn_to_param_1 ?d_new)) (at end (compiled_turn_to_param_1 ?d_new)) (over all (compiled_turn_to_param_2 ?d_prev)) (at start (compiled_turn_to_param_2 ?d_prev)) (at end (compiled_turn_to_param_2 ?d_prev)) (at start (compiled_turn_to_started)) (over all (compiled_turn_to_started)) (at end (compiled_turn_to_started)) (at start (compiled_turn_to_stage1_enabled)) (over all (compiled_turn_to_stage1_enabled)))
:effect (and (at end (not (compiled_turn_to_stage1_enabled))) (at end (compiled_turn_to_stage2_enabled))))
(:durative-action compiled_turn_to_stage2
:parameters (?s - satellite ?d_new - direction ?d_prev - direction)
:duration (= ?duration 0.999)
:condition (and (over all (compiled_turn_to_param_0 ?s)) (at start (compiled_turn_to_param_0 ?s)) (at end (compiled_turn_to_param_0 ?s)) (over all (compiled_turn_to_param_1 ?d_new)) (at start (compiled_turn_to_param_1 ?d_new)) (at end (compiled_turn_to_param_1 ?d_new)) (over all (compiled_turn_to_param_2 ?d_prev)) (at start (compiled_turn_to_param_2 ?d_prev)) (at end (compiled_turn_to_param_2 ?d_prev)) (at start (compiled_turn_to_started)) (over all (compiled_turn_to_started)) (at end (compiled_turn_to_started)) (at start (compiled_turn_to_stage2_enabled)) (over all (compiled_turn_to_stage2_enabled)) (over all (compiled_shadow_pointing ?s ?d_new)))
:effect (and (at end (not (compiled_turn_to_stage2_enabled))) (at end (compiled_turn_to_finished)) (at start (compiled_shadow_pointing ?s ?d_new))))
(:durative-action switch_on
:parameters (?i - instrument ?s - satellite)
:duration (= ?duration 2.0)
:condition (and (at start (power_avail ?s)) (at end (compiled_switch_on_finished)) (over all (on_board ?i ?s)))
:effect (and (at start (not (compiled_shadow_calibrated ?i))) (at start (compiled_switch_on_param_0 ?i)) (at end (not (compiled_switch_on_param_0 ?i))) (at start (compiled_switch_on_param_1 ?s)) (at end (not (compiled_switch_on_param_1 ?s))) (at start (not (calibrated ?i))) (at start (not (power_avail ?s))) (at start (compiled_switch_on_started)) (at start (compiled_switch_on_stage1_enabled)) (at end (power_on ?i)) (at end (not (compiled_switch_on_finished))) (at end (not (compiled_switch_on_started)))))
(:durative-action compiled_switch_on_stage1
:parameters (?i - instrument ?s - satellite)
:duration (= ?duration 0.998)
:condition (and (over all (compiled_switch_on_param_0 ?i)) (at start (compiled_switch_on_param_0 ?i)) (at end (compiled_switch_on_param_0 ?i)) (over all (compiled_switch_on_param_1 ?s)) (at start (compiled_switch_on_param_1 ?s)) (at end (compiled_switch_on_param_1 ?s)) (at start (compiled_switch_on_started)) (over all (compiled_switch_on_started)) (at end (compiled_switch_on_started)) (at start (compiled_switch_on_stage1_enabled)) (over all (compiled_switch_on_stage1_enabled)))
:effect (and (at end (not (compiled_switch_on_stage1_enabled))) (at end (compiled_switch_on_stage2_enabled))))
(:durative-action compiled_switch_on_stage2
:parameters (?i - instrument ?s - satellite)
:duration (= ?duration 0.999)
:condition (and (over all (compiled_switch_on_param_0 ?i)) (at start (compiled_switch_on_param_0 ?i)) (at end (compiled_switch_on_param_0 ?i)) (over all (compiled_switch_on_param_1 ?s)) (at start (compiled_switch_on_param_1 ?s)) (at end (compiled_switch_on_param_1 ?s)) (at start (compiled_switch_on_started)) (over all (compiled_switch_on_started)) (at end (compiled_switch_on_started)) (at start (compiled_switch_on_stage2_enabled)) (over all (compiled_switch_on_stage2_enabled)) (over all (compiled_shadow_power_on ?i)))
:effect (and (at end (not (compiled_switch_on_stage2_enabled))) (at end (compiled_switch_on_finished)) (at start (compiled_shadow_power_on ?i))))
(:durative-action calibrate
:parameters (?s - satellite ?i - instrument ?d - direction)
:duration (= ?duration 5.0)
:condition (and (at start (pointing ?s ?d)) (at end (compiled_calibrate_finished)) (over all (on_board ?i ?s)) (over all (calibration_target ?i ?d)) (over all (power_on ?i)) (over all (compiled_shadow_power_on ?i)))
:effect (and (at start (compiled_calibrate_param_0 ?s)) (at end (not (compiled_calibrate_param_0 ?s))) (at start (compiled_calibrate_param_1 ?i)) (at end (not (compiled_calibrate_param_1 ?i))) (at start (compiled_calibrate_param_2 ?d)) (at end (not (compiled_calibrate_param_2 ?d))) (at start (compiled_calibrate_started)) (at start (compiled_calibrate_stage1_enabled)) (at end (calibrated ?i)) (at end (not (compiled_calibrate_finished))) (at end (not (compiled_calibrate_started)))))
(:durative-action compiled_calibrate_stage1
:parameters (?s - satellite ?i - instrument ?d - direction)
:duration (= ?duration 3.998)
:condition (and (over all (compiled_calibrate_param_0 ?s)) (at start (compiled_calibrate_param_0 ?s)) (at end (compiled_calibrate_param_0 ?s)) (over all (compiled_calibrate_param_1 ?i)) (at start (compiled_calibrate_param_1 ?i)) (at end (compiled_calibrate_param_1 ?i)) (over all (compiled_calibrate_param_2 ?d)) (at start (compiled_calibrate_param_2 ?d)) (at end (compiled_calibrate_param_2 ?d)) (at start (compiled_calibrate_started)) (over all (compiled_calibrate_started)) (at end (compiled_calibrate_started)) (at start (compiled_calibrate_stage1_enabled)) (over all (compiled_calibrate_stage1_enabled)))
:effect (and (at end (not (compiled_calibrate_stage1_enabled))) (at end (compiled_calibrate_stage2_enabled))))
(:durative-action compiled_calibrate_stage2
:parameters (?s - satellite ?i - instrument ?d - direction)
:duration (= ?duration 0.999)
:condition (and (over all (compiled_calibrate_param_0 ?s)) (at start (compiled_calibrate_param_0 ?s)) (at end (compiled_calibrate_param_0 ?s)) (over all (compiled_calibrate_param_1 ?i)) (at start (compiled_calibrate_param_1 ?i)) (at end (compiled_calibrate_param_1 ?i)) (over all (compiled_calibrate_param_2 ?d)) (at start (compiled_calibrate_param_2 ?d)) (at end (compiled_calibrate_param_2 ?d)) (at start (compiled_calibrate_started)) (over all (compiled_calibrate_started)) (at end (compiled_calibrate_started)) (at start (power_on ?i)) (over all (power_on ?i)) (at end (power_on ?i)) (at start (compiled_calibrate_stage2_enabled)) (over all (compiled_calibrate_stage2_enabled)) (over all (compiled_shadow_calibrated ?i)) (at start (compiled_shadow_power_on ?i)) (over all (compiled_shadow_power_on ?i)) (at end (compiled_shadow_power_on ?i)))
:effect (and (at end (not (compiled_calibrate_stage2_enabled))) (at end (compiled_calibrate_finished)) (at start (compiled_shadow_calibrated ?i))))
(:durative-action take_image
:parameters (?s - satellite ?d - direction ?i - instrument ?m - mode)
:duration (= ?duration 7.0)
:condition (and (at end (compiled_take_image_finished)) (over all (calibrated ?i)) (over all (on_board ?i ?s)) (over all (supports ?i ?m)) (over all (power_on ?i)) (over all (pointing ?s ?d)) (over all (compiled_shadow_power_on ?i)) (over all (compiled_shadow_calibrated ?i)))
:effect (and (at start (compiled_take_image_param_0 ?s)) (at end (not (compiled_take_image_param_0 ?s))) (at start (compiled_take_image_param_1 ?d)) (at end (not (compiled_take_image_param_1 ?d))) (at start (compiled_take_image_param_2 ?i)) (at end (not (compiled_take_image_param_2 ?i))) (at start (compiled_take_image_param_3 ?m)) (at end (not (compiled_take_image_param_3 ?m))) (at start (compiled_take_image_started)) (at start (compiled_take_image_stage1_enabled)) (at end (have_image ?d ?m)) (at end (not (compiled_take_image_finished))) (at end (not (compiled_take_image_started)))))
(:durative-action compiled_take_image_stage1
:parameters (?s - satellite ?d - direction ?i - instrument ?m - mode)
:duration (= ?duration 4.998)
:condition (and (over all (compiled_take_image_param_0 ?s)) (at start (compiled_take_image_param_0 ?s)) (at end (compiled_take_image_param_0 ?s)) (over all (compiled_take_image_param_1 ?d)) (at start (compiled_take_image_param_1 ?d)) (at end (compiled_take_image_param_1 ?d)) (over all (compiled_take_image_param_2 ?i)) (at start (compiled_take_image_param_2 ?i)) (at end (compiled_take_image_param_2 ?i)) (over all (compiled_take_image_param_3 ?m)) (at start (compiled_take_image_param_3 ?m)) (at end (compiled_take_image_param_3 ?m)) (at start (compiled_take_image_started)) (over all (compiled_take_image_started)) (at end (compiled_take_image_started)) (at start (compiled_take_image_stage1_enabled)) (over all (compiled_take_image_stage1_enabled)))
:effect (and (at end (not (compiled_take_image_stage1_enabled))) (at end (compiled_take_image_stage2_enabled))))
(:durative-action compiled_take_image_stage2
:parameters (?s - satellite ?d - direction ?i - instrument ?m - mode)
:duration (= ?duration 1.999)
:condition (and (over all (compiled_take_image_param_0 ?s)) (at start (compiled_take_image_param_0 ?s)) (at end (compiled_take_image_param_0 ?s)) (over all (compiled_take_image_param_1 ?d)) (at start (compiled_take_image_param_1 ?d)) (at end (compiled_take_image_param_1 ?d)) (over all (compiled_take_image_param_2 ?i)) (at start (compiled_take_image_param_2 ?i)) (at end (compiled_take_image_param_2 ?i)) (over all (compiled_take_image_param_3 ?m)) (at start (compiled_take_image_param_3 ?m)) (at end (compiled_take_image_param_3 ?m)) (at start (compiled_take_image_started)) (over all (compiled_take_image_started)) (at end (compiled_take_image_started)) (at start (power_on ?i)) (over all (power_on ?i)) (at end (power_on ?i)) (at start (compiled_take_image_stage2_enabled)) (over all (compiled_take_image_stage2_enabled)) (over all (compiled_shadow_have_image ?d ?m)) (at start (compiled_shadow_power_on ?i)) (over all (compiled_shadow_power_on ?i)) (at end (compiled_shadow_power_on ?i)))
:effect (and (at end (not (compiled_take_image_stage2_enabled))) (at end (compiled_take_image_finished)) (at start (compiled_shadow_have_image ?d ?m))))
)
