(define (domain domain-tms-2-3-light)
(:requirements :strips :typing :durative-actions)
(:types
   piece - object
   kiln - object
   piecetype1 - piece
   piecetype2 - piece
   piecetype3 - piece
   kiln8 - kiln
   kiln20 - kiln)
(:predicates
   (energy)
   (ready ?k - kiln)
   (baking ?p - piece)
   (treated ?p - piece)
   (baked ?p - piece)
   (structured ?p1 - piece ?p2 - piece)
   (baked-structure ?p1 - piece ?p2 - piece)
   (compiled_shadow_treated ?p - piece)
   (compiled_treat-ceramic1_param_0 ?p - piece)
   (compiled_treat-ceramic1_x)
   (compiled_treat-ceramic1_y)
   (compiled_treat-ceramic2_param_0 ?p - piecetype2)
   (compiled_treat-ceramic2_x)
   (compiled_treat-ceramic2_y)
   (compiled_treat-ceramic3_param_0 ?p - piecetype3)
   (compiled_treat-ceramic3_x)
   (compiled_treat-ceramic3_y))
(:durative-action fire-kiln1
:parameters (?k - kiln8)
:duration (= ?duration 8000)
:condition (over all (energy))
:effect (and (at start (ready ?k)) (at end (not (ready ?k)))))
(:durative-action fire-kiln2
:parameters (?k - kiln20)
:duration (= ?duration 20000)
:condition (over all (energy))
:effect (and (at start (ready ?k)) (at end (not (ready ?k)))))
(:durative-action bake-ceramic1
:parameters (?p - piecetype1 ?k - kiln)
:duration (= ?duration 15000)
:condition (over all (ready ?k))
:effect (and (at start (not (baked ?p))) (at start (baking ?p)) (at end (not (baking ?p))) (at end (baked ?p))))
(:durative-action bake-ceramic2
:parameters (?p - piecetype2 ?k - kiln)
:duration (= ?duration 10000)
:condition (over all (ready ?k))
:effect (and (at start (not (baked ?p))) (at start (baking ?p)) (at end (not (baking ?p))) (at end (baked ?p))))
(:durative-action bake-ceramic3
:parameters (?p - piecetype3 ?k - kiln)
:duration (= ?duration 5000)
:condition (over all (ready ?k))
:effect (and (at start (not (baked ?p))) (at start (baking ?p)) (at end (not (baking ?p))) (at end (baked ?p))))
(:durative-action make-structure
:parameters (?p1 - piece ?p2 - piece)
:duration (= ?duration 1000)
:condition (and (over all (baked ?p1)) (over all (treated ?p1)) (over all (baked ?p2)) (over all (treated ?p2)))
:effect (and (at end (structured ?p1 ?p2))))
(:durative-action bake-structure
:parameters (?p1 - piece ?p2 - piece ?k - kiln)
:duration (= ?duration 3000)
:condition (and (over all (ready ?k)) (over all (structured ?p1 ?p2)))
:effect (and (at start (not (baked-structure ?p1 ?p2))) (at end (baked-structure ?p1 ?p2))))
(:durative-action compiled_treat-ceramic1_clip
:parameters ()
:duration (= ?duration 2)
:condition (and (at start (compiled_treat-ceramic1_y)))
:effect (and (at start (compiled_treat-ceramic1_x)) (at end (not (compiled_treat-ceramic1_x)))))
(:durative-action treat-ceramic1
:parameters (?p - piece)
:duration (= ?duration 999)
:condition (and (at end (compiled_treat-ceramic1_x)) (over all (baking ?p)) (over all (compiled_treat-ceramic1_param_0 ?p)) (at end (compiled_treat-ceramic1_param_0 ?p)))
:effect (and (at start (compiled_treat-ceramic1_y)) (at end (not (compiled_treat-ceramic1_y))) (at start (compiled_treat-ceramic1_param_0 ?p))))
(:durative-action compiled_treat-ceramic1_stage2
:parameters (?p - piece)
:duration (= ?duration 2000)
:condition (and (at start (compiled_treat-ceramic1_x)) (over all (compiled_treat-ceramic1_param_0 ?p)) (at start (compiled_treat-ceramic1_param_0 ?p)) (at end (compiled_treat-ceramic1_param_0 ?p)) (over all (baking ?p)) (over all (compiled_shadow_treated ?p)))
:effect (and (at end (not (compiled_treat-ceramic1_param_0 ?p))) (at end (treated ?p)) (at start (compiled_shadow_treated ?p))))
(:durative-action compiled_treat-ceramic2_clip
:parameters ()
:duration (= ?duration 2)
:condition (and (at start (compiled_treat-ceramic2_y)))
:effect (and (at start (compiled_treat-ceramic2_x)) (at end (not (compiled_treat-ceramic2_x)))))
(:durative-action treat-ceramic2
:parameters (?p - piecetype2)
:duration (= ?duration 999)
:condition (and (at end (compiled_treat-ceramic2_x)) (over all (baking ?p)) (over all (compiled_treat-ceramic2_param_0 ?p)) (at end (compiled_treat-ceramic2_param_0 ?p)))
:effect (and (at start (compiled_treat-ceramic2_y)) (at end (not (compiled_treat-ceramic2_y))) (at start (compiled_treat-ceramic2_param_0 ?p))))
(:durative-action compiled_treat-ceramic2_stage2
:parameters (?p - piecetype2)
:duration (= ?duration 1000)
:condition (and (at start (compiled_treat-ceramic2_x)) (over all (compiled_treat-ceramic2_param_0 ?p)) (at start (compiled_treat-ceramic2_param_0 ?p)) (at end (compiled_treat-ceramic2_param_0 ?p)) (over all (baking ?p)) (over all (compiled_shadow_treated ?p)))
:effect (and (at end (not (compiled_treat-ceramic2_param_0 ?p))) (at end (treated ?p)) (at start (compiled_shadow_treated ?p))))
(:durative-action compiled_treat-ceramic3_clip
:parameters ()
:duration (= ?duration 2)
:condition (and (at start (compiled_treat-ceramic3_y)))
:effect (and (at start (compiled_treat-ceramic3_x)) (at end (not (compiled_treat-ceramic3_x)))))
(:durative-action treat-ceramic3
:parameters (?p - piecetype3)
:duration (= ?duration 999)
:condition (and (at end (compiled_treat-ceramic3_x)) (over all (baking ?p)) (over all (compiled_treat-ceramic3_param_0 ?p)) (at end (compiled_treat-ceramic3_param_0 ?p)))
:effect (and (at start (compiled_treat-ceramic3_y)) (at end (not (compiled_treat-ceramic3_y))) (at start (compiled_treat-ceramic3_param_0 ?p))))
(:durative-action compiled_treat-ceramic3_stage2
:parameters (?p - piecetype3)
:duration (= ?duration 1000)
:condition (and (at start (compiled_treat-ceramic3_x)) (over all (compiled_treat-ceramic3_param_0 ?p)) (at start (compiled_treat-ceramic3_param_0 ?p)) (at end (compiled_treat-ceramic3_param_0 ?p)) (over all (baking ?p)) (over all (compiled_shadow_treated ?p)))
:effect (and (at end (not (compiled_treat-ceramic3_param_0 ?p))) (at end (treated ?p)) (at start (compiled_shadow_treated ?p))))
)
